#ifndef SampleEventHandler_H
#define SampleEventHandler_H


#include "EventHandler.H"
#include "Random.H"

class GameStateModule;


// This class gives the event handler access to all game and gfx data

struct SampleAIState {

  GameStateModule * gsm;
  bool quit;       // true => quit game
  bool error;      // true <=> error occurred
 
  SampleAIState(GameStateModule * gsm_):
    gsm(gsm_)
  {
    quit = error = false;
  }

};


// This class handles server events
// In particular it generates game object actions

class SampleEventHandler : public EventHandler {

public:

  SampleAIState &state;
  sint4 strategy;

  SampleEventHandler(SampleAIState &state_, sint4 seed, sint4 _strategy = 0) : state(state_) {
    rand.srand(seed);
    strategy = _strategy;
    strategy = rand.rand_uint4() % 3;
  }

  bool handle_event(const Event &e);

private:
  void compute_actions();
  Random rand; // local RNG

};

#endif
